# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This class is auto generated by the elixir code generator program.
# Do not edit the class manually.

defmodule GoogleApi.Monitoring.V3.Model.CollectdValue do
  @moduledoc """
  A single data point from a collectd-based plugin.

  ## Attributes

  *   `dataSourceName` (*type:* `String.t`, *default:* `nil`) - The data source for the collectd value. For example there are two data sources for network measurements: "rx" and "tx".
  *   `dataSourceType` (*type:* `String.t`, *default:* `nil`) - The type of measurement.
  *   `value` (*type:* `GoogleApi.Monitoring.V3.Model.TypedValue.t`, *default:* `nil`) - The measurement value.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :dataSourceName => String.t(),
          :dataSourceType => String.t(),
          :value => GoogleApi.Monitoring.V3.Model.TypedValue.t()
        }

  field(:dataSourceName)
  field(:dataSourceType)
  field(:value, as: GoogleApi.Monitoring.V3.Model.TypedValue)
end

defimpl Poison.Decoder, for: GoogleApi.Monitoring.V3.Model.CollectdValue do
  def decode(value, options) do
    GoogleApi.Monitoring.V3.Model.CollectdValue.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Monitoring.V3.Model.CollectdValue do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
