# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This class is auto generated by the elixir code generator program.
# Do not edit the class manually.

defmodule GoogleApi.Monitoring.V3.Model.CreateCollectdTimeSeriesRequest do
  @moduledoc """
  The CreateCollectdTimeSeries request.

  ## Attributes

  *   `collectdPayloads` (*type:* `list(GoogleApi.Monitoring.V3.Model.CollectdPayload.t)`, *default:* `nil`) - The collectd payloads representing the time series data. You must not include more than a single point for each time series, so no two payloads can have the same values for all of the fields plugin, plugin_instance, type, and type_instance.
  *   `collectdVersion` (*type:* `String.t`, *default:* `nil`) - The version of collectd that collected the data. Example: "5.3.0-192.el6".
  *   `resource` (*type:* `GoogleApi.Monitoring.V3.Model.MonitoredResource.t`, *default:* `nil`) - The monitored resource associated with the time series.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :collectdPayloads => list(GoogleApi.Monitoring.V3.Model.CollectdPayload.t()),
          :collectdVersion => String.t(),
          :resource => GoogleApi.Monitoring.V3.Model.MonitoredResource.t()
        }

  field(:collectdPayloads, as: GoogleApi.Monitoring.V3.Model.CollectdPayload, type: :list)
  field(:collectdVersion)
  field(:resource, as: GoogleApi.Monitoring.V3.Model.MonitoredResource)
end

defimpl Poison.Decoder, for: GoogleApi.Monitoring.V3.Model.CreateCollectdTimeSeriesRequest do
  def decode(value, options) do
    GoogleApi.Monitoring.V3.Model.CreateCollectdTimeSeriesRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Monitoring.V3.Model.CreateCollectdTimeSeriesRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
