# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This class is auto generated by the elixir code generator program.
# Do not edit the class manually.

defmodule GoogleApi.Monitoring.V3.Model.GetNotificationChannelVerificationCodeResponse do
  @moduledoc """
  The GetNotificationChannelVerificationCode request.

  ## Attributes

  *   `code` (*type:* `String.t`, *default:* `nil`) - The verification code, which may be used to verify other channels that have an equivalent identity (i.e. other channels of the same type with the same fingerprint such as other email channels with the same email address or other sms channels with the same number).
  *   `expireTime` (*type:* `DateTime.t`, *default:* `nil`) - The expiration time associated with the code that was returned. If an expiration was provided in the request, this is the minimum of the requested expiration in the request and the max permitted expiration.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :code => String.t(),
          :expireTime => DateTime.t()
        }

  field(:code)
  field(:expireTime, as: DateTime)
end

defimpl Poison.Decoder,
  for: GoogleApi.Monitoring.V3.Model.GetNotificationChannelVerificationCodeResponse do
  def decode(value, options) do
    GoogleApi.Monitoring.V3.Model.GetNotificationChannelVerificationCodeResponse.decode(
      value,
      options
    )
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.Monitoring.V3.Model.GetNotificationChannelVerificationCodeResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
