# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This class is auto generated by the elixir code generator program.
# Do not edit the class manually.

defmodule GoogleApi.Monitoring.V3.Model.ListTimeSeriesResponse do
  @moduledoc """
  The ListTimeSeries response.

  ## Attributes

  *   `executionErrors` (*type:* `list(GoogleApi.Monitoring.V3.Model.Status.t)`, *default:* `nil`) - Query execution errors that may have caused the time series data returned to be incomplete.
  *   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - If there are more results than have been returned, then this field is set to a non-empty value. To see the additional results, use that value as pageToken in the next call to this method.
  *   `timeSeries` (*type:* `list(GoogleApi.Monitoring.V3.Model.TimeSeries.t)`, *default:* `nil`) - One or more time series that match the filter included in the request.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :executionErrors => list(GoogleApi.Monitoring.V3.Model.Status.t()),
          :nextPageToken => String.t(),
          :timeSeries => list(GoogleApi.Monitoring.V3.Model.TimeSeries.t())
        }

  field(:executionErrors, as: GoogleApi.Monitoring.V3.Model.Status, type: :list)
  field(:nextPageToken)
  field(:timeSeries, as: GoogleApi.Monitoring.V3.Model.TimeSeries, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.Monitoring.V3.Model.ListTimeSeriesResponse do
  def decode(value, options) do
    GoogleApi.Monitoring.V3.Model.ListTimeSeriesResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Monitoring.V3.Model.ListTimeSeriesResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
