# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This class is auto generated by the elixir code generator program.
# Do not edit the class manually.

defmodule GoogleApi.Monitoring.V3.Model.CollectdPayloadError do
  @moduledoc """
  Describes the error status for payloads that were not written.

  ## Attributes

  *   `error` (*type:* `GoogleApi.Monitoring.V3.Model.Status.t`, *default:* `nil`) - Records the error status for the payload. If this field is present, the partial errors for nested values won't be populated.
  *   `index` (*type:* `integer()`, *default:* `nil`) - The zero-based index in CreateCollectdTimeSeriesRequest.collectd_payloads.
  *   `valueErrors` (*type:* `list(GoogleApi.Monitoring.V3.Model.CollectdValueError.t)`, *default:* `nil`) - Records the error status for values that were not written due to an error.Failed payloads for which nothing is written will not include partial value errors.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :error => GoogleApi.Monitoring.V3.Model.Status.t(),
          :index => integer(),
          :valueErrors => list(GoogleApi.Monitoring.V3.Model.CollectdValueError.t())
        }

  field(:error, as: GoogleApi.Monitoring.V3.Model.Status)
  field(:index)
  field(:valueErrors, as: GoogleApi.Monitoring.V3.Model.CollectdValueError, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.Monitoring.V3.Model.CollectdPayloadError do
  def decode(value, options) do
    GoogleApi.Monitoring.V3.Model.CollectdPayloadError.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Monitoring.V3.Model.CollectdPayloadError do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
